	freeslot("MT_ROBOTAILSBOMB", "S_ROBOTAILSBOMB1", "S_ROBOTAILSBOMB2","S_ROBOTAILSBOMB3", "S_ROBOTAILSBOMB4", "S_ROBOTAILSBOMB5", "S_ROBOTAILSBOMB6", "S_ROBOTAILSBOMB7", "S_ROBOTAILSBOMB8")
	mobjinfo[MT_ROBOTAILSBOMB] = {
		painstate = S_NULL,
		seestate = S_NULL,
		seesound = sfx_s3k51,
		attacksound = sfx_none,
		painsound = sfx_none,
		meleestate = S_NULL,
		missilestate = S_NULL,
		xdeathstate = S_NULL,
		raisestate = S_NULL,
		spawnhealth = 1,
		reactiontime = 0,
		painchance = 0,
		activesound = sfx_none,
		mass = 0,
		damage = 38*FRACUNIT,
		deathsound = sfx_s3k4e,
		spawnstate = S_ROBOTAILSBOMB1,
		speed = 20*FRACUNIT,
		radius = 24*FRACUNIT,
		height = 48*FRACUNIT,
		deathstate = S_ROBOTAILSBOMB3,
		flags = MF_NOBLOCKMAP|MF_MISSILE
	}

	states[S_ROBOTAILSBOMB1] = {
	sprite = SPR_FBOM,
	frame = A,
	tics = 1,
	nextstate = S_ROBOTAILSBOMB2,
	action = A_GhostMe
	}
	
	states[S_ROBOTAILSBOMB2] = {
	sprite = SPR_FBOM,
	frame = B,
	tics = 1,
	nextstate = S_ROBOTAILSBOMB1,
	action = A_GhostMe
	}
	
	states[S_ROBOTAILSBOMB3] = {
	sprite = SPR_BARX,
	frame = A|FF_FULLBRIGHT,
	tics = 3,
	nextstate = S_ROBOTAILSBOMB4,
	action = A_SetObjectFlags,
	var1 = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP
	}
	
	states[S_ROBOTAILSBOMB4] = {
	sprite = SPR_BARX,
	frame = B|FF_FULLBRIGHT,
	tics = 2,
	nextstate = S_ROBOTAILSBOMB5,
	action = A_Explode,
	var1 = 0
	}
	
	states[S_ROBOTAILSBOMB5] = {
	sprite = SPR_BARX,
	frame = B|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_ROBOTAILSBOMB6
	}
	
	states[S_ROBOTAILSBOMB6] = {
	sprite = SPR_BARX,
	frame = C|FF_FULLBRIGHT,
	tics = 3,
	nextstate = S_ROBOTAILSBOMB7
	}
	
	states[S_ROBOTAILSBOMB7] = {
	sprite = SPR_BARX,
	frame = D|FF_FULLBRIGHT,
	tics = 3,
	nextstate = S_ROBOTAILSBOMB8
	}
	
	states[S_ROBOTAILSBOMB8] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 2*TICRATE,
	nextstate = S_NULL
	}
	
	addHook("PlayerThink", function (player)
		if (player.bombtimer == nil) then
		player.candropbomb = true 
		player.bombtimer = 0
		end
			if (player.rtsuperjumptimer == nil)
			player.rtsuperjumptimer = 0
			end
	end)
		
	addHook("PlayerThink", function(player)
		if (player.rtsuperjumptimer >= 1)
		player.rtsuperjumptimer = $ - 1
		end
	end)
	
	addHook("MusicChange", function(oldname, newname)
		for player in players.iterate do
			if (newname == "_CLEAR" or newname == "_clear" and player.isrobotails) then
			return "_RTVIC"
			end
		end
	end)
	
	//this is slightly stupid 
	//but ok
	addHook("PlayerThink", function(player)
		if (player.mo and player.mo.valid and player.mo.skin == "robotails") then
		player.isrobotails = true
		else
		player.isrobotails = false
		end
	end)
	
	addHook("PlayerThink", function(player)
		if (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_STND)
		or (player.mo.state == S_PLAY_WAIT)
			if player.dashmode == 2*TICRATE then
			player.dashmode = 3*TICRATE
			end
		end
	end)
		
	local function IsBattle()
		if (gametype == GT_BATTLE or gametype == GT_CP 
		or gametype == GT_ARENA or gametype == GT_SURVIVAL
		or gametype == GT_TEAMBATTLE or gametype == GT_TEAMCP or gametype == GT_BATTLECTF  or gametype == GT_TEAMARENA or gametype == GT_TEAMSURVIVAL
		or gametype == GT_DIAMOND or gametype == GT_TEAMDIAMOND or gametype == GT_EGGROBOTAG)
		return true
		else
		return false
		end
	end
	
	addHook("PlayerThink", function(player)
		if not (player.mo.skin == "robotails") then
		return end
			if (player.mo.state ~= S_PLAY_FLY) then
			return end
				if (player.candropbomb == false) then
				return end	
					if IsBattle()
					return end
						if (player.cmd.buttons == BT_CUSTOM1) then
						local bomb = P_SpawnPlayerMissile(player.mo, MT_ROBOTAILSBOMB, MF2_RAILRING)
							if bomb and bomb.valid then
							bomb.colorized = true
							bomb.momx = 0
							bomb.momy = 0
								if (player.powers[pw_super]) then
								player.bombtimer = 70
								player.candropbomb = false
								elseif not (player.powers[pw_super])
								player.bombtimer = 105
								player.candropbomb = false
							end
					end
			end
	end)
	
	addHook("PlayerThink", function(player) 
		if (player.bombtimer >= 1) then
		player.bombtimer = $ - 1
			if (player.candropbomb == false and player.bombtimer == 0) then
			player.candropbomb = true
			end
		end
	end)
	
	//if you're trying to revive this character, ignore this ability honestly it's pretty useless
	//like the only use it has is if you roll off a cliff, and that rarely happens if it's not intentional -TLKG (1:45 PM 6/20/2023)
	/*
	addHook("PlayerThink", function(player)
		if not (player.mo.skin == "robotails") then
		return end
			if (player.pflags & PF_NOJUMPDAMAGE) 
			and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) then
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
	end)
	
	addHook("PlayerThink", function(player)
		if not (player.mo.skin == "robotails") then
		return end
			if (player.mo and player.mo.valid and player.cmd.buttons == BT_CUSTOM1 and player.mo.state == S_PLAY_ROLL) 
			and not P_IsObjectOnGround(player.mo) then
			P_Thrust(player.mo, player.mo.angle, -5*FRACUNIT)
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_SPINNING	
			player.charflags = $ | PF_NOJUMPDAMAGE
		end
	end)
	*/
	
	//how did I look at this and think it was ok -TLKG (1:49 PM 6/20/2023)
	//that's better, old hideous code gone -TLKG (12:26 PM 6/22/2023)
	addHook("PlayerThink", function(player)
		if (player.mo ~= nil and player.mo and player.mo.skin == "robotails")
			if (player.mo.state == S_PLAY_FLY)
			and not (player.cmd.buttons & BT_JUMP or player.cmd.buttons & BT_SPIN)
			and not (player.powers[pw_super])  then
			player.mo.momz = 4*FRACUNIT*P_MobjFlip(player.mo)
			elseif (player.powers[pw_super] and player.mo.state == S_PLAY_FLY)
			and not (player.cmd.buttons & BT_JUMP or player.cmd.buttons & BT_SPIN) then
			player.mo.momz = 8*FRACUNIT*P_MobjFlip(player.mo)
			elseif (player.powers[pw_super] and player.mo.skin == "robotails" and player.mo.state == S_PLAY_FLY and player.cmd.buttons & BT_SPIN)
			and not (player.cmd.buttons & BT_JUMP) then
			player.mo.momz = -8*FRACUNIT*P_MobjFlip(player.mo)
			elseif (player.mo.skin == "robotails" and player.mo.state == S_PLAY_FLY and player.cmd.buttons & BT_SPIN)
			and not (player.cmd.buttons & BT_JUMP)
			and not (player.powers[pw_super])then
			player.mo.momz = -5*FRACUNIT*P_MobjFlip(player.mo)
			end
		end
	end)
	